#include "asl.h"

int saveConstFloats(char *FLOAT_TABLE[], char *constValue, int valueLen) {
	char *buffer = (char*)malloc(sizeof(char) * (bitNum + 1));
	memset(buffer, '\0', bitNum + 1);
	FLOAT_TABLE[constFloatNum] = (char*)malloc(sizeof(char) * (bitNum + 1));
	memset(FLOAT_TABLE[constFloatNum], '\0', bitNum + 1);
	
	hex_to_binary(constValue, valueLen, buffer, bitNum);	
	//printf("buffer = %s\n", buffer);
	if (buffer == NULL) return -1;
	
	if (strlen(buffer) < bitNum) buffer = signExtend(buffer, bitNum);//caseof 0x0
	strcpy(FLOAT_TABLE[constFloatNum], buffer);
	//printf("float table %d = %s\n", constFloatNum, FLOAT_TABLE[constFloatNum]);	
	constFloatNum++;
	free(buffer);
	return 0;	
}

int saveLabels(char *labelName, int lineNum, char **label[], int option) {
	int real_lineNum;
	char *buf = (char*)malloc(sizeof(char) * (bitNum + 1));
	memset(buf, '\0', bitNum + 1);
	
	if (option == 1) {//add new label
		real_lineNum = lineNum - labelNum - constFloatNum - neglectNum;		
		label[labelNum] = (char**)malloc(sizeof(char*) * 2);
		label[labelNum][0] = (char*)malloc(sizeof(char) * 128);
		memset(label[labelNum][0], '\0', 128);
		strcpy(label[labelNum][0], labelName);//label L1:
	}
	else //only update position of this label
		real_lineNum = lineNum;
	
	buf = my_itoa(real_lineNum, buf, 19, 2); //jal target(19-0) 
	label[labelNum][1] = (char*)malloc(sizeof(char) * (bitNum + 1));
	memset(label[labelNum][1], '\0', bitNum + 1);
	strcpy(label[labelNum][1], buf);//position (line number) of L1: save in (bitNum - 6) bit length
	//printf("label name = %s\n", label[labelNum][0]);
	//printf("label code = %s\n", label[labelNum][1]);
	labelNum++;
	free(buf);
	return SUCCEEDED;	
}

int getLabels(int lineNum, char *cmdLine[], char **op[], char **label[], char *FLOAT_TABLE[]) {	
	
	if (cmdLine[0][strlen(cmdLine[0]) - 1] == ':') {
		cmdLine[0][strlen(cmdLine[0]) - 1] = '\0';					
		if (saveLabels(cmdLine[0], lineNum, label, 1) == FAILED) return FAILED;
	}
	else if (strcmp(cmdLine[0], ".long") == 0) {
		labelNum--;//rewrite the position of the Label just before
		if (saveLabels(NULL, TOTAL_INSTRUCTIONS_NUM + constFloatNum, label, 0) == FAILED) return FAILED;			
		if (saveConstFloats(FLOAT_TABLE, cmdLine[1], strlen(cmdLine[1])) == FAILED) return FAILED;
	}
	else if (cmdLine[0][0] == '.') {
		neglectNum++;
		//neglect : .global...
	}
	return SUCCEEDED;
}

int countInstructions(char *cmdLine[], char **op[]) {
	int i;
	if (strcmp(cmdLine[0], "li") == 0 || strcmp(cmdLine[0], "ll") == 0) {
		lineNum++;
		return SUCCEEDED;
	}
	for (i = 0; i < opNum; i++) {//opNum: the real operators number
		if (strcmp(cmdLine[0], op[i][1]) == 0) {
			return SUCCEEDED;
		}		
	}	
	if (i != -1) {// no operator found, but
		if (cmdLine[0][strlen(cmdLine[0]) - 1] == ':') {
			labelNum++;
		}
		else if (strcmp(cmdLine[0], ".long") == 0) {
			constFloatNum++;
		}
		else if (cmdLine[0][0] == '.') {
			neglectNum++;
			//neglect : .global...
		}
		else {// neither operator nor label
			fprintf(stderr, "line %d: %s: operator not found!\n", lineNum, cmdLine[0]);
			return FAILED;
		}
	}
	return SUCCEEDED;
}

char* signExtend(char *str, int len) {	
	int size, i;
	char *buf = (char*)malloc(sizeof(char) * (len + 1));
	memset(buf, '\0', len + 1);
	size = strlen(str);
	//printf("Size of moto = %d\n", size);
	//strcpy(buf, "");
	for (i = 0; i < len - size; i++) {
		strcat(buf, "0");
	}
	strcat(buf, str);
	//printf("xxx buf = %s\n", buf);
	return buf;
}

int assemble(int lineNum, char *cmdLine[], int cmdLength, char **op[], char **reg[], char **label[], FILE *fd)
{
	/*  change directly assembly keywords(add, sub...) 
		and registers' name (r1, r2...) written in assembly 
		command line cmdLine into binary code
		due to opcode array op[] and registers array reg[]
		the result will be printed out into the file fd
		
		return 0 if success, -1 if fail somewhere
	*/
	int i, k, operand_num, operator_type, tmpLen, OPERATOR_FOUND = FALSE, op_now;
	int x;
	unsigned int pst;
	char *buf = (char*)malloc(sizeof(char) * (bitNum + 1));;
	char *tmp_buf, *tmp_buf_lohi;
	char *tmp;
	char **tmp_cmdLine;
	int ret1, ret2;
	memset(buf, '\0', bitNum + 1);	
	
	printf("-------line %d\n", lineNum);
	
	if (cmdLine[0][strlen(cmdLine[0]) - 1] == ':' || strcmp(cmdLine[0], ".long") == 0 || cmdLine[0][0] == '.') {
		free(buf);
		return SUCCEEDED;
	}
	
	if (strcmp(cmdLine[0], "li") == 0) {
		printf("li: created 2 instructions:\n");
		strcpy(cmdLine[0], "llo");
		ret1 = assemble(lineNum, cmdLine, cmdLength, op, reg, label, fd);
		strcpy(cmdLine[0], "lhi");
		ret2 = assemble(lineNum, cmdLine, cmdLength, op, reg, label, fd);
		if (ret1 == SUCCEEDED && ret2 == SUCCEEDED) return SUCCEEDED;
		else return FAILED;
	}
	
	if (//strcmp(cmdLine[0], "li") == 0 ||
		//strcmp(cmdLine[0], "ll") == 0 ||
		strcmp(cmdLine[0], "move") == 0 ||
		strcmp(cmdLine[0], "neg") == 0) {
			tmp_cmdLine = (char **)malloc(sizeof(char*) * (cmdLength + 1));
			
			for (i = 0; i < cmdLength + 1; i++) {
				tmp_cmdLine[i] = (char*)malloc(sizeof(char) * 1024);
				memset(tmp_cmdLine[i], '\0', 1024);
				if (i > 0 && i < cmdLength - 1)
					strcpy(tmp_cmdLine[i], cmdLine[i]);
			}
			//if (strcmp(cmdLine[0], "li") == 0) strcpy(tmp_cmdLine[0], "addi");
			//else if (strcmp(cmdLine[0], "ll") == 0) strcpy(tmp_cmdLine[0], "addi");
			if (strcmp(cmdLine[0], "move") == 0) strcpy(tmp_cmdLine[0], "add");
			else if (strcmp(cmdLine[0], "neg") == 0) strcpy(tmp_cmdLine[0], "sub");
			
			strcpy(tmp_cmdLine[cmdLength - 1], "$r0");
			strcpy(tmp_cmdLine[cmdLength], cmdLine[cmdLength - 1]);
			free(buf);
			return assemble(lineNum, tmp_cmdLine, cmdLength + 1, op, reg, label, fd);
	}
	
	/*search sequently if this operator belongs to the operators set or not*/
	for (op_now = 0; op_now < opNum; op_now++) {//opNum: the real operators number
		
		if (strcmp(cmdLine[0], op[op_now][1]) == 0) {
			printf("OPCODE = %s\n", op[op_now][1]);			
			strcpy(buf, op[op_now][0]);			
			operand_num = atoi(op[op_now][2]);//get the number of operands for this operator			
			operator_type = atoi(op[op_now][3]);
			//printf("operator type = %d\n", operator_type);
			OPERATOR_FOUND = TRUE;//operator must be found! !!!!!!!!!
			break;
		}		
	}	
	
	//printf("cmdLength = %d\n", cmdLength);
	//printf("operand_num = %d\n", operand_num);
	if (cmdLength < operand_num + 1) {
		fprintf(stderr, "line %d: invalid operand length\n", lineNum);
		return FAILED; 
	}
	
	switch (operator_type) {
	case 1: //R-type instructions : ADD, SUB
		for (k = 1; k <= operand_num; k++) //n operands
		{
			for (i = 0; i < regNum; i++)//regNum: the real registers number 		
			{
				if (strcmp(cmdLine[k], reg[i][1]) == 0)	{					
								
					strcat(buf, reg[i][0]);
					i = -1;				
					break;
				}						
			}
			if (i != -1) {
				fprintf(stderr, "line %d: %s: register not found!\n", lineNum, cmdLine[k]);
				return FAILED;
			}
		}
		break;
		
	case 2: //I-type instructions : LOAD, STORE: load r1 r2 N
		if (strcmp(cmdLine[0], "lw") == 0 || strcmp(cmdLine[0], "sw") == 0) {//lw rd Imm(rs) : rd = mem[rs + Imm] --> lw rd rs Imm
			tmp = (char *)malloc(sizeof(char) * 128);
			memset(tmp, '\0', 128);
			strcpy(tmp, cmdLine[2]);
			strcpy(cmdLine[2], cmdLine[3]);
			strcpy(cmdLine[3], tmp);
			free(tmp);
		}
		for (k = 1; k <= operand_num; k++) //addi r1 r2 N.   N(15-0)
		{
			if (k == operand_num) {//immediate value
				tmp_buf = (char*)malloc(sizeof(char) * (bitNum + 1));
				memset(tmp_buf, '\0', bitNum + 1);
				pst = atoi(cmdLine[k]);
				if (pst == 0) //not a number --> 0 : !!!!!!!!!!!!
					if (cmdLine[k][0] != '0' && strlen(cmdLine[k]) != 1) {
						fprintf(stderr, "line %d: imm %s is not suitable!\n", lineNum, cmdLine[k]);
						free(tmp_buf);
						free(buf);
						return FAILED;
					}
				tmp_buf = my_itoa(atoi(cmdLine[k]), tmp_buf, 32, 2);
				if (tmp_buf == NULL) {
					fprintf(stderr, "line %d: imm %s overflowed!\n", lineNum, cmdLine[k]);
					free(tmp_buf);
					free(buf);
					return FAILED;
				}
				
				tmp_buf_lohi = (char*)malloc(sizeof(char) * (bitNum/2 + 1));
				memset(tmp_buf_lohi, '\0', bitNum/2 + 1);
				if (strcmp(cmdLine[0], "lhi") == 0) //lhi rd Hi(Imm)					
					strncpy(tmp_buf_lohi, tmp_buf, bitNum/2);				
				else //llo rd Lo(Imm) and normal I-type instructions ... !
					strncpy(tmp_buf_lohi, tmp_buf + bitNum/2, bitNum/2);					
				
				strcpy(tmp_buf, tmp_buf_lohi);				
				strcat(buf, signExtend(tmp_buf, bitNum - 6 - (operand_num - 1) * 5));//no need to extend !
				//strcat(buf, tmp_buf);
				free(tmp_buf_lohi);
				free(tmp_buf);
				continue;
			}
			//registers			
			for (i = 0; i < regNum; i++)//regNum: the real registers number
			{
				if (strcmp(cmdLine[k], reg[i][1]) == 0)	{
					strcat(buf, reg[i][0]);
					i = -1;				
					break;
				}						
			}
			if (i != -1) {
				fprintf(stderr, "line %d: %s: register not found!\n", lineNum, cmdLine[k]);
				free(buf);
				return FAILED;
			}
		}
		break;
	
	case 3: //A-type instructions:	JUMP, BE.. special case : ll rd label_name(16 bit width = Imm)
		for (k = 1; k <= operand_num; k++) //n operands
		{
			if (k == operand_num) {//immediate value
				for (i = 0; i < labelNum; i++) {
					if (strcmp(cmdLine[k], label[i][0]) == 0) {
						//sign extended !:
						if (strcmp(cmdLine[0], "ll") == 0) {
							pst = my_atoi(label[i][1], 2);
							sprintf(cmdLine[k], "%u", pst);
							
							printf("li: created 2 instructions: t = %u\n", pst);
							strcpy(cmdLine[0], "llo");
							ret1 = assemble(lineNum, cmdLine, cmdLength, op, reg, label, fd);
							strcpy(cmdLine[0], "lhi");
							ret2 = assemble(lineNum, cmdLine, cmdLength, op, reg, label, fd);
							free(buf);
							if (ret1 == SUCCEEDED && ret2 == SUCCEEDED) return SUCCEEDED;
							else return FAILED;							
						}
						strcat(buf, signExtend(label[i][1], bitNum - 6 - (operand_num - 1)* 5));// no need to extend ?!
						i = -1;				
						break;
					}				
				}
				if (i != -1) {
					//printf("line %d: %s: LABEL not found! Replace this address by 0.\n", lineNum, cmdLine[k]);//label not found --> target := 0
					fprintf(stderr, "line %d: %s: LABEL not found! Replace this address by 0.\n", lineNum, cmdLine[k]);//label not found --> target := 0
					tmp_buf = (char*)malloc(sizeof(char) * (bitNum + 1));
					memset(tmp_buf, '\0', bitNum + 1);
					tmp_buf = my_itoa(0, tmp_buf, bitNum - 6 - (operand_num - 1)* 5, 2);					
					strcat(buf, tmp_buf);
					free(tmp_buf);
					//return FAILED;
				}
				continue;
			}
			//registers
			for (i = 0; i < regNum; i++)//regNum: the real registers number
			{
				if (strcmp(cmdLine[k], reg[i][1]) == 0)	{
					strcat(buf, reg[i][0]);
					i = -1;
					break;
				}						
			}
			if (i != -1) {
				fprintf(stderr, "line %d: %s: register not found!\n", lineNum, cmdLine[k]);
				free(buf);
				return FAILED;
			}
		}		
		break;
	}
	tmpLen = strlen(buf);
	for (i = bitNum - 1; i >= tmpLen; i--) {
		strcat(buf, "0");//fill in the tail in order to make 32 bit length
	}
	printf("dumped code = %s\n", buf);
	//fwrite(get_code_from_string(buf), 1, bitNum+1, fd);//buf length = 32. last element = '\n'
	x  =  get_code_from_string(buf);
	fprintf(fd, "%c%c%c%c", x & 255, (x>>8) & 255, (x>>16) & 255, (x>>24) & 255);
	free(buf);
	return SUCCEEDED;
}

void printFloatTable(char *FLOAT_TABLE[], FILE *fd) {
	int i, x;
	x = 0;
	fprintf(fd, "%c%c%c%c", x & 255, (x>>8) & 255, (x>>16) & 255, (x>>24) & 255);
	for (i = 0; i < constFloatNum; i++) {
		x = get_code_from_string(FLOAT_TABLE[i]);
		fprintf(fd, "%c%c%c%c", x & 255, (x>>8) & 255, (x>>16) & 255, (x>>24) & 255);
		//fwrite(buf, 1, bitNum + 1, stdout);
	}
}
