#include "asl.h"

int load_table(char path[], char **op[])
{
	/* 	read from text file opcode table or registers list
		and load them into op array or reg array
		return the actual number of operators or registers
	*/ 
	char input[1024];
	int r;
	int k = 0;
	FILE *fp;
	fp = fopen(path, "r");
	if (fp < 0) 
	{
		printf("load_table() :%s: File not found!\n", path);
		return -1;
	}
	else printf("load_table() :%s loaded!\n", path);
  	
	while (fgets(input, 128, fp) > 0) {
		op[k] = (char **)malloc(sizeof(char*) * 10);
	  	r = parse(input, op[k]);		
		if (r == 0) continue;
		/*printf("Number of tokens: %d\n", r);
	  	for (i = 0; i < r; i++)
	  	{
	    	printf("op(%d)[%d] = %s\n", k, i, op[k][i]);
	  	}*/
	  	k++;
	}
	fclose(fp);
	return k;
}



void reverse_char(char *a, unsigned long len) {
	unsigned long i;
	char tmp;
	for (i = 0; i <= (len-1)/2 ; i++) {
		tmp = a[i];
		a[i] = a[len - 1 - i];
		a[len - 1 - i] = tmp;
	}
}

char *my_itoa(int a, char *buffer, int buff_size, int radix) {
	char *temp;
	int b;
	int len = buff_size;
	temp = buffer;

	b = a;
	if (buffer == NULL)
		return NULL;
	
	while (a > 0 || buff_size > 0) {
		if (buff_size < 1) return NULL;

		b = a % radix;
		*temp = b + '0';
		temp++;
		a = a / radix;
		buff_size--;
	}
	*temp = '\0';
	/*Note : You have to Add a String reverse Function on this buffer here*/
	reverse_char(buffer, len - buff_size);
	return buffer;
}

/*
char* hex_to_binary(char *input, int input_size, char *buffer, int buffer_size) {	
	char* word = (char *)malloc(5 * sizeof(char));
	int i, code;
	
	if (input[0] != '0' || input[1] != 'x' || buffer_size < 4 * (input_size - 2)) {
		printf("hex_to_binary: Not suitable input!\n");
		return NULL;
	}	
	for (i = 2; i < input_size; i++) {
		code = input[i] - 48;
		if (code > 15) code -= 39;
		printf("%d\n", code);
		word = my_itoa(code, word, 4, 2);
		printf("%s\n", word);
		strcat(buffer, word);
	}
	free(word);	
	return buffer;
}
*/

char* hex_to_binary(char *input, int input_size, char *buffer, int buffer_size) {
	int i;
	if (input[0] != '0' || input[1] != 'x' || buffer_size < 4 * (input_size - 2)) {
		printf("hex_to_binary: Not suitable input!\n");
		return NULL;
	}
	for (i = 2; i < input_size; i++)
		switch(input[i])
		{
			case '0':
				strcat(buffer, "0000");
			break;
			case '1':
				strcat(buffer, "0001");
			break;
			case '2':
				strcat(buffer, "0010");
			break;
			case '3':
				strcat(buffer, "0011");
			break;
			case '4':
				strcat(buffer, "0100");
			break;
			case '5':
				strcat(buffer, "0101");
			break;
			case '6':
				strcat(buffer, "0110");
			break;
			case '7':
				strcat(buffer, "0111");
			break;
			case '8':
				strcat(buffer, "1000");
			break;
			case '9':
				strcat(buffer, "1001");
			break;
			case 'a':
			case 'A':
				strcat(buffer, "1010");
			break;
			case 'b':
			case 'B':
				strcat(buffer, "1011");
			break;
			case 'c':
			case 'C':
				strcat(buffer, "1100");
			break;
			case 'd':
			case 'D':
				strcat(buffer, "1101");
			break;
			case 'e':
			case 'E':
				strcat(buffer, "1110");
			break;
			case 'f':
			case 'F':
				strcat(buffer, "1111");
			break;
			default:
				printf("Entered number is not Hexadecimal.Printed value is not correct.");
			break;
		}
		//buffer[buffer_size] = '\0';
		//printf("my buffer = %s\n", buffer);
		return buffer;
}

int get_code_from_string(char* buf)
{
	int x, i;
	x = 0;
	for (i = 0; i < 32; i++) {
		x <<= 1;
		if (buf[i] == '1') x |= 1;// x + 1		
	}
	//printf("buf = %s, x = %x\n", buf, x);
	return x;
}

int member(char c, char str[])
{
	int i;
  	int length = strlen(str);
  	for (i = 0; i < length; i++) {
    	if (c == str[i]) return TRUE;
  	}
  	return FALSE;
}

unsigned int my_atoi(char str[], int radix) {
	int i;
	int len = strlen(str);
	unsigned int sum = str[0] - 48;
	for (i = 1; i < len; i++) {
		sum = sum * radix + (str[i] - 48);
	}	
	return sum;	
}
